"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReferencesNode = void 0;
const object_utils_js_1 = require("../util/object-utils.js");
/**
 * @internal
 */
exports.ReferencesNode = (0, object_utils_js_1.freeze)({
    is(node) {
        return node.kind === 'ReferencesNode';
    },
    create(table, columns) {
        return (0, object_utils_js_1.freeze)({
            kind: 'ReferencesNode',
            table,
            columns: (0, object_utils_js_1.freeze)([...columns]),
        });
    },
    cloneWithOnDelete(references, onDelete) {
        return (0, object_utils_js_1.freeze)({
            ...references,
            onDelete,
        });
    },
    cloneWithOnUpdate(references, onUpdate) {
        return (0, object_utils_js_1.freeze)({
            ...references,
            onUpdate,
        });
    },
});
