"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseCommonTableExpression = void 0;
const common_table_expression_node_js_1 = require("../operation-node/common-table-expression-node.js");
const common_table_expression_name_node_js_1 = require("../operation-node/common-table-expression-name-node.js");
function parseCommonTableExpression(ctx, name, expression) {
    const builder = expression(ctx.createQueryCreator());
    return common_table_expression_node_js_1.CommonTableExpressionNode.create(parseCommonTableExpressionName(name), builder.toOperationNode());
}
exports.parseCommonTableExpression = parseCommonTableExpression;
function parseCommonTableExpressionName(name) {
    if (name.includes('(')) {
        const parts = name.split(/[\(\)]/);
        const table = parts[0];
        const columns = parts[1].split(',').map((it) => it.trim());
        return common_table_expression_name_node_js_1.CommonTableExpressionNameNode.create(table, columns);
    }
    else {
        return common_table_expression_name_node_js_1.CommonTableExpressionNameNode.create(name);
    }
}
