/// <reference types="./complex-expression-parser.d.ts" />
import { isOperationNodeSource } from '../operation-node/operation-node-source.js';
import { isFunction } from '../util/object-utils.js';
export function parseComplexExpression(ctx, exp) {
    if (isOperationNodeSource(exp)) {
        return exp.toOperationNode();
    }
    else if (isFunction(exp)) {
        return exp(ctx.createExpressionBuilder()).toOperationNode();
    }
    throw new Error(`invalid expression: ${JSON.stringify(exp)}`);
}
export function parseAliasedComplexExpression(ctx, exp) {
    if (isOperationNodeSource(exp)) {
        return exp.toOperationNode();
    }
    else if (isFunction(exp)) {
        return exp(ctx.createExpressionBuilder()).toOperationNode();
    }
    throw new Error(`invalid aliased expression: ${JSON.stringify(exp)}`);
}
export function isComplexExpression(obj) {
    return isOperationNodeSource(obj) || isFunction(obj);
}
